Trigger.prototype.checkStructures = function(msg)
{
	if (TriggerHelper.HasClass(msg.building, "House"))
		this.houseCount++;
	if (TriggerHelper.HasClass(msg.building, "DropsiteWood"))
		this.dropsiteWoodBuild++;
	if (TriggerHelper.HasClass(msg.building, "DropsiteFood"))
		this.farmsteadBuild++;
	if (TriggerHelper.HasClass(msg.building, "Field"))
		this.fieldBuild++;
	if (TriggerHelper.HasClass(msg.building, "Barracks"))
		this.barracksCount++;
	if (TriggerHelper.HasClass(msg.building, "Village"))
		this.villageCount++;
	if (TriggerHelper.HasClass(msg.building, "Market"))
		this.marketCount++;
	if (this.IsDone())
		this.NextGoal();
}
Trigger.prototype.checkStructuresDel = function(msg)
{
	if (msg.cmd.type == "delete-entities") {
		if (TriggerHelper.HasClass(msg.cmd.entities[0], "House"))
			this.houseCount--;
		if (TriggerHelper.HasClass(msg.cmd.entities[0], "DropsiteWood"))
			this.dropsiteWoodBuild--;
		if (TriggerHelper.HasClass(msg.cmd.entities[0], "DropsiteFood"))
			this.farmsteadBuild--;
		if (TriggerHelper.HasClass(msg.cmd.entities[0], "Field"))
			this.fieldBuild--;
		if (TriggerHelper.HasClass(msg.cmd.entities[0], "Barracks"))
			this.barracksCount--;
		if (TriggerHelper.HasClass(msg.cmd.entities[0], "Village"))
			this.villageCount--;
		if (TriggerHelper.HasClass(msg.cmd.entities[0], "Market"))
			this.marketCount--;
	}
}
Trigger.prototype.hasResources = function(list)
{
	return TriggerHelper.HasResources(this.playerID, list);
}
Trigger.prototype.tutorialGoals = [
	{
		"Init": function() {
			this.houseCount = 0;
			this.barracksCount = 0;
			this.dropsiteWoodBuild = 0;
			this.farmsteadBuild = 0;
			this.fieldBuild = 0;
			this.marketCount = 0;
			this.villageCount = 0;
			this.unitsWomanTrained = false;
			this.unitsWoodTrained = false;
			this.traderTrained = false;
			this.hasTP = false;
			this.tradeS = -1;
		},
		"delay": -1,
		"IsDone": function()
		{
			return false;
		},
		"instructions": [
			markForTranslation("This is your Civil Center, very important building as you can train more workers and citizen-soldiers from there. Also grants you territory.")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnResearchFinished": function(msg)
		{
			if (TriggerHelper.IsResearched(this.playerID, "phase_town_athen"))
				this.hasTP = true;
		}
		
	},
	{
		"instructions": [
			markForTranslation("On the left there are women. They are good at collecting food. Select one of them using left mouse click and send them to collect fruit bushes by right-clicking on them.\n"),
		],
		"tasks": [
			markForTranslation("- task woman to collect fruit\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnPlayerCommand": function(msg)
		{
			this.checkStructuresDel(msg);
			if (msg.cmd.entities && TriggerHelper.HasClass(msg.cmd.entities[0], "FemaleCitizen") && msg.cmd.type == "gather" && msg.cmd.target &&
				TriggerHelper.GetResourceType(msg.cmd.target).specific == "fruit")
				this.NextGoal();
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"IsDone": function()
		{
			return false;
		}
	},
	{
		"instructions": [
			markForTranslation("Well done. Now select some spearman and send them to cut some trees for wood. Citizen-soldiers are better at wood, stone and metal gathering than women.\n")
		],
		"tasks": [
			markForTranslation("- task spearman to chop trees\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnPlayerCommand": function(msg)
		{
			this.checkStructuresDel(msg);
			if (msg.cmd.entities && TriggerHelper.HasClass(msg.cmd.entities[0], "CitizenSoldier") && msg.cmd.type == "gather" && msg.cmd.target &&
				TriggerHelper.GetResourceType(msg.cmd.target).specific == "tree")
				this.NextGoal();
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"IsDone": function()
		{
			return false;
		}
	},
	{
		"instructions": [
			markForTranslation("Good job.\nYou may noticed chickens around your Civic Center.\nSelect your cavalry and send them to slaughter some chicken for food.\n\nCavalry is the best choice for hunter because of speed they have.\n"),
		],
		"tasks": [
			markForTranslation("- send cavalry to slaughter chickens\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnPlayerCommand": function(msg)
		{
			this.checkStructuresDel(msg);
			if (msg.cmd.entities && TriggerHelper.HasClass(msg.cmd.entities[0], "Cavalry") && msg.cmd.type == "gather" && msg.cmd.target &&
				TriggerHelper.GetResourceType(msg.cmd.target).specific == "meat")
				this.NextGoal();
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
	},
	{
		"delay": -1,
		"instructions": [
			markForTranslation("You can select all units of the same type double clicking at them.\n"),
			markForTranslation("Select remaining women and send them to gather food.\n"),
			markForTranslation("Do the same with citizen-soldiers and send them to chop some trees.\n")
		],
		"tasks": [
			markForTranslation("- give some job to all workers\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("You will need more wood to build your village. To faster your production, you need more workers.\n"),
			markForTranslation("Select Civic Center with left-click.\n"),
			markForTranslation("Here you can train more women and citizen-soldiers and also research some technologies.\n"),
			markForTranslation("First, let's set rallypoint for every unit comming out from this building.\n"),
			markForTranslation("They will automatically perform given task or walk to the given position.\n"),
			markForTranslation("With selected Civic Center, right-click at some tree.\n"),
			markForTranslation("Rally points are indicated by a small flag at the end of the blue line.\n"),
		],
		"tasks": [	
			markForTranslation("- set rallypoint\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnPlayerCommand": function(msg)
		{
			if (msg.cmd.type == "toogle-goals")
				return;
			this.checkStructuresDel(msg);
			if (msg.cmd.type != "set-rallypoint" || !msg.cmd.data ||
			   !msg.cmd.data.command || msg.cmd.data.command != "gather" ||
			   !msg.cmd.data.resourceType || msg.cmd.data.resourceType.specific != "tree")
			{
				return;
			}
			this.NextGoal();
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},

	},
	{
		"delay": -1,
		"instructions": [
			markForTranslation("Excelent. New workers will automatically go to chop trees.\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("At the top side of right selection panel, you can see icons of available units to train.\n"),
			markForTranslation("You can left-click at the icon to produce one.\n"),
			markForTranslation("But you can be more effective with training more units at once.\n"),
			{
				"text": markForTranslation("Hold %(hotkey)s and click at Slinger icon.\n"),
				"hotkey": "session.batchtrain"
			}
		],
		"tasks": [		
			markForTranslation("- train 5 Slingers\n")
		],
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
		"OnTrainingQueued": function(msg)
		{
			if (msg.unitTemplate != "units/athen_infantry_slinger_b" || +msg.count == 1)
			{
				let entity = msg.trainerEntity;
				let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
				cmpProductionQueue.ResetQueue();
				return;
			}
			this.NextGoal();
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("To gain resources, workers need to bring them to the dropsite.\n"),
			markForTranslation("Civic Center is general dropsite, but you can build some closer to the resources.\n"),
			markForTranslation("Select all your citizen-soldiers.\n"),
			markForTranslation("At the right side of selection panel, you can see buildings which can be started with this unit.\n"),
			markForTranslation("Find Storehouse and left-click at the icon.\n"),
			markForTranslation("Now place it as close to the trees as possible using left-click.\n"),
			markForTranslation("\nYou can rotate building while placing by holding left mouse button pressed and dragging cursor around structure.\n"),			
		],
		"tasks": [	
			markForTranslation("- start construction of storehouse\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnTrainingFinished": function(msg)
		{
			this.unitsWoodTrained = true;
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
			if (msg.cmd.type == "construct" && msg.cmd.template == "structures/athen_storehouse")
				this.NextGoal();
		},
		"IsDone": function()
		{
			return this.dropsiteWoodBuild;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("The selected citizens will automatically start constructing the building once you place the foundation.\n"),
			markForTranslation("When construction of dropsite is finished, builders will search for closest resource they can collect.\n"),
		],
		"tasks": [
			markForTranslation("- wait for dropsite to be build\n"),
			markForTranslation("- wait for workers to be trained\n"),
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"IsDone": function()
		{
			return this.dropsiteWoodBuild && this.unitsWoodTrained;
		},
		"OnTrainingFinished": function(msg)
		{
			this.unitsWoodTrained = true;
			if (this.IsDone())
				this.NextGoal();
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("Now you should have enough workers gathering wood.\n"),
			markForTranslation("Let's remove rallypoint for Civic Center.\n"),
			markForTranslation("Select Civic Center and right-click at it to remove rallypoint.\n"),
		],
		"tasks": [	
			markForTranslation("- remove rallypoint\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
			if (msg.cmd.type == "unset-rallypoint")
				this.NextGoal();
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
	},
	{
		"Init": function()
		{
			this.unitsWomanTrained = false;
		},
		"instructions": [
			markForTranslation("Well done.\n"),
			markForTranslation("You still need more workers.\n"),
			{
				"text": markForTranslation("Select Civic Center and train group of women using %(hotkey)s key.\n"),
				"hotkey": "session.batchtrain"
			},
			markForTranslation("You can notice, they do cost only food.\n"),
		],
		"tasks": [	
			markForTranslation("- train 5 women\n")
		],
		"OnTrainingQueued": function(msg)
		{
			if (msg.unitTemplate != "units/athen_support_female_citizen" || +msg.count != 5)
			{
				let entity = msg.trainerEntity;
				let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
				cmpProductionQueue.ResetQueue();
				return;
			}
			this.NextGoal();
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("At the left side of the top panel, you can see resources you have and the last number is your population cap.\n"),
			markForTranslation("First part tells you how many units do you currently have and second informs you how many you can place for.\n"),
			markForTranslation("To enlarge place for workers, you need to build some houses.\n"),
			markForTranslation("Select one or more workers and build house.\n"),
			{
				"text": markForTranslation("To select multiple workers, select one worker, then hold %(hotkey)s and left-click at another.\n"),
				"hotkey": "selection.add"
			}
		],
		"tasks": [
			markForTranslation("- build at least one house\n"),
			markForTranslation("- wait for women to be trained\n")
		],
		"OnTrainingQueued": function(msg) {
			let entity = msg.trainerEntity;
			let cmpProductionQueue = Engine.QueryInterface(entity, IID_ProductionQueue);
			cmpProductionQueue.ResetQueue();
		},
		"OnTrainingFinished": function(msg)
		{
			this.unitsWomanTrained = true;
			if (this.IsDone())
				this.NextGoal();
		},
		"IsDone": function()
		{
			return this.houseCount && this.unitsWomanTrained;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("Great. Remember to keep an eye at population limit.\n"),
			markForTranslation("Your cavalry may be idle by now. Select it and find some wild animals to hunt.\n"),
		],
		"tasks": [	
			markForTranslation("- send cavalry to hunt\n")
		],
		"OnPlayerCommand": function(msg)
		{
			this.checkStructuresDel(msg);
			if (msg.cmd.entities && TriggerHelper.HasClass(msg.cmd.entities[0], "Cavalry") && msg.cmd.type == "gather" && msg.cmd.target &&
				TriggerHelper.GetResourceType(msg.cmd.target).specific == "meat")
				this.NextGoal();
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		
	},
	{
		"instructions": [
			markForTranslation("As you can see, there are not much fruit bushes. To secure your food income, you should build fields.\n"),
			markForTranslation("But before that, it is adviced to build farmstead, so you can put them around it.\n"),
			{
				"text": markForTranslation("\nTo queue any order hold %(hotkey)s while giving it. Units will do it after they finish current one.\n"),
				"hotkey": "session.queue"
			},
			markForTranslation("You can apply that for placing buildings too.\n"),
			markForTranslation("\nSelect some women.\n"),
			markForTranslation("Select Farmstead to build.\n"),
			{
				"text": markForTranslation("Press and hold %(hotkey)s\n"),
				"hotkey": "session.queue"
			},
			markForTranslation("Place building with left-click.\n"),
			markForTranslation("Select Field from buildings and place it.\n"),
			{
				"text": markForTranslation("Release %(hotkey)s\n"),
				"hotkey": "session.queue"
			},
			markForTranslation("To cancel placing of building use right-click.\n")
		],
		"tasks": [	
			markForTranslation("- build farmstead\n"),
			markForTranslation("- build at least one field")
		],
		"IsDone": function()
		{
			return this.farmsteadBuild && this.fieldBuild;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		}
	},
	{
		"instructions": [
			markForTranslation("You can have 5 workers working at one Field. Women are better at collecting grain from fields then men.\n"),
			markForTranslation("Now let's improve your economy with technologies.\n")
		],
		"delay": -1,
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("Select Farmstead.\n"),
			markForTranslation("At the bottom part of right selection panel you can see technologies to research.\n"),
			markForTranslation("These technologies will improve your fruit and grain gathering.\n"),
			markForTranslation("Pick one and research it.\n"),
		],
		"tasks": [
			markForTranslation("- research one technology from Farmstead\n")
		],
		"OnResearchQueued": function(msg)
		{
			if (msg.technologyTemplate && TriggerHelper.EntityMatchesClassList(msg.researcherEntity, "Farmstead"))
				this.NextGoal();
		},
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("Very well.\n"),
			markForTranslation("You can similary improve collection of another resources from Storehouse.\n"),
			markForTranslation("\n"),
			markForTranslation("You should look ahead to promote your village into a town.\n"),
			markForTranslation("To do so, you need to have build some buildings and/or trained some units.\n"),
			markForTranslation("Select Civic Center and hover over technology with II icon.\n"),
			markForTranslation("You can see all requirements you need to fulfill before you can resaearch this technology.\n")
		],
		"delay": -1,
		"IsDone": function()
		{
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("Let's build Barracks so you have more options from where you can train workers.\n"),
			markForTranslation("It will also help with phase requirements.\n"),
			markForTranslation("You can send more workers to build already placed foundation to speed up building process.\n"),
		],
		"tasks": [
			markForTranslation("- build Barracks\n"),
		],
		"IsDone": function()
		{
			return this.barracksCount;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("You need to build more structures from Village phase to unlock next phase.\n"),
			markForTranslation("To know which structure is from Village phase, select some worker and hover over possible buildings.\n"),
			markForTranslation("Under Class in tooltip you will see 'Village' or 'Town' or 'City'.\n")
		],
		"tasks": [
			markForTranslation("- have 4 Village structures\n"),
		],
		"IsDone": function()
		{
			return this.villageCount > 4;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("You should now meet all requirements to research Town Phase.\n"),
			markForTranslation("Now you need to collect more resources to be able to research next phase.\n"),
			markForTranslation("After that, select Civic Center and research technology with II icon.\n"),
		],
		"tasks": [
			markForTranslation("- have 500 wood\n"),
			markForTranslation("- have 500 food\n"),
			markForTranslation("- research Town Phase (II)\n"),
		],
		"OnResearchQueued": function(msg)
		{
			if (msg.technologyTemplate && TriggerHelper.EntityMatchesClassList(msg.researcherEntity, "CivilCentre"))
				this.NextGoal();
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
		"IsDone": function()
		{
			if (this.hasTP)
				return true;
			if (this.hasResources({"wood": 500, "food": 500}))
				return true;
			if (TriggerHelper.HasDealtWithTech(this.playerID, "phase_town_athen"))
				return true;
			return false;
		}
	},
	{
		"instructions": [
			markForTranslation("You should now meet all requirements to research Town Phase.\n"),
			markForTranslation("Select Civic Center and research technology with II icon.\n"),
		],
		"tasks": [
			markForTranslation("- research Town Phase (II)\n")
		],
		"OnResearchQueued": function(msg)
		{
			if (msg.technologyTemplate && TriggerHelper.EntityMatchesClassList(msg.researcherEntity, "CivilCentre"))
				this.NextGoal();
		},
		"IsDone": function()
		{
			if (this.hasTP)
				return true;
			if (TriggerHelper.HasDealtWithTech(this.playerID, "phase_town_athen"))
				return true;
			return false;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("Now is good time to start collection of stone for advanced buildings.\n"),
			markForTranslation("As your Civic Center is busy with research, you can use Barracks for training more workers.\n"),
			markForTranslation("Do not forget to build houses.\n"),
		],
		"tasks": [
			markForTranslation("- task some workers to collect stone \n")
		],
		"IsDone": function()
		{
			return false;
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
			if (msg.cmd.type == "gather" && msg.cmd.target && TriggerHelper.GetResourceType(msg.cmd.target).generic == "stone")
				this.NextGoal();	
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnResearchFinished": function(msg)
		{
			if (this.hasTP)
				return;
			if (TriggerHelper.IsResearched(this.playerID, "phase_town_athen"))
				this.hasTP = true;
		},
	},
	{
		"instructions": [
			markForTranslation("Just one more resource to collect.\n"),
			markForTranslation("Metal is mainly used for research and to train advanced soldiers.\n"),
		],
		"tasks": [
			markForTranslation("- task some workers to collect metal\n")
		],
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
			if (msg.cmd.type == "gather" && msg.cmd.target && TriggerHelper.GetResourceType(msg.cmd.target).generic == "metal")
				this.NextGoal();	
		},
		"OnResearchFinished": function(msg)
		{
			if (this.hasTP)
				return;
			if (TriggerHelper.IsResearched(this.playerID, "phase_town_athen"))
				this.hasTP = true;
		},
		"OnTrainingFinished": function(msg) {
			if (msg.entities && TriggerHelper.HasClass(msg.entities[0], "Trader"))
				this.traderTrained = true;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"IsDone": function() {
			return false;
		}
	},
	{
		"instructions": [
			markForTranslation("Great.\n"),
			markForTranslation("While you are waiting to reach Town Phase, you can improve your economy with "),
			markForTranslation("building more fields, tasking more workers to collect some resources or researching more technologies "),
			markForTranslation("in Farmstead or Storehouse")
		],
		"tasks": [
			markForTranslation("- wait to new phase is reached\n")
		],
		"OnResearchFinished": function(msg)
		{
			if (this.hasTP)
				return;
			if (TriggerHelper.IsResearched(this.playerID, "phase_town_athen"))
				this.hasTP = true;
			if (this.IsDone())
				this.NextGoal();
		},
		"IsDone": function()
		{
			return this.hasTP;
		},
		"OnTrainingFinished": function(msg) {
			if (msg.entities && TriggerHelper.HasClass(msg.entities[0], "Trader"))
				this.traderTrained = true;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("You have entered new Town Phase.\n"),
			markForTranslation("Build Market to unlock barter and trading.\n"),
		],
		"tasks": [
			markForTranslation("- build Market\n")
		],
		"IsDone": function()
		{
			return this.marketCount;
		},
		"OnTrainingFinished": function(msg) {
			if (msg.entities && TriggerHelper.HasClass(msg.entities[0], "Trader"))
				this.traderTrained = true;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("Market allows you to barter resources and speed up your progress.\n"),
			markForTranslation("Select Market.\n"),
			markForTranslation("At the left bottom you have two rows of resources.\n"),
			markForTranslation("Clicking at the first row, you select which resource you want to sell.\n"),
			markForTranslation("Clicking at the second row, you barter that resource for resource from the first row.\n")
		],
		"tasks": [
			markForTranslation("- barter resources\n"),
		], 
		"IsDone": function()
		{
			return false;
		},
		"OnTrainingFinished": function(msg) {
			if (msg.entities && TriggerHelper.HasClass(msg.entities[0], "Trader"))
				this.traderTrained = true;
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
			if (msg.cmd.type == "barter") 
				this.NextGoal();
		}
	},
	{
		"instructions": [
			markForTranslation("You can set trading route between two markets.\n"),
			markForTranslation("One market has to be yours and another can be yours or of your ally.\n"),
			markForTranslation("Longer trading route means higher income.\n"),
			markForTranslation("Build second Market as far from first one as possible.\n"),
		],
		"tasks": [
			markForTranslation("- build second Market\n")
		],
		"IsDone": function()
		{
			return this.marketCount > 1;
		},
		"OnTrainingFinished": function(msg) {
			if (msg.entities && TriggerHelper.HasClass(msg.entities[0], "Trader"))
				this.traderTrained = true;
			if (this.IsDone())
				this.NextGoal();
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("Train Trader from Market so you can set trading route.\n"),
		],
		"tasks": [
			markForTranslation("- train Trader\n")
		],
		"IsDone": function()
		{
			return this.traderTrained;
		},
		"OnTrainingFinished": function(msg) {
			if (msg.entities && TriggerHelper.HasClass(msg.entities[0], "Trader"))
				this.traderTrained = true;
			if (this.IsDone())
				this.NextGoal();
		},
		"OnStructureBuilt": function(msg) {
			this.checkStructures(msg);
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
		},
	},
	{
		"instructions": [
			markForTranslation("You can set trading route between two markets.\n"),
			markForTranslation("One market has to be yours and another can be yours or of your ally.\n"),
			markForTranslation("Longer trading route means higher income.\n\n"),
			markForTranslation("Select your Trader.\n"),
			markForTranslation("Right click on first Market.\n"),
			markForTranslation("Right click on second Market.\n"),
		],
		"tasks": [
			markForTranslation("- setup trading route\n")
		],
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
			if (msg.cmd.type == "setup-trade-route" && msg.cmd.target) {
				if (this.tradeS != -1 && this.tradeS != msg.cmd.target)
					this.NextGoal();
				this.tradeS = msg.cmd.target;
			}
		},
		"IsDone": function()
		{
			return false;
		}
	},
	{
		"instructions": [
			markForTranslation("Well done.\n"),
			markForTranslation("Now Trader will generate resources for you.\n"),
			markForTranslation("If you want to specify which resource you want to get, click at the top right panel to Barter & Trade icon.\n"),
			markForTranslation("There you can change which resources will traders generate.\n")
		],
		"tasks": [
			markForTranslation("- change traded resources"),
		],
		"IsDone": function() {
			return false;
		},
		"OnPlayerCommand": function(msg) {
			this.checkStructuresDel(msg);
			if (msg.cmd.type == "set-trading-goods")
				this.NextGoal();
		}
	},
	{
		"instructions": [
			markForTranslation("You done well.\n\n"),
			markForTranslation("This is the end of tutorial.\n"),
			markForTranslation("Have fun playing the game.\n")
		]
	}
];

{
	let cmpTrigger = Engine.QueryInterface(SYSTEM_ENTITY, IID_Trigger);
	cmpTrigger.playerID = 1;
	cmpTrigger.RegisterTrigger("OnInitGame", "InitTutorial", { "enabled": true });
}
